﻿Type=Service
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'Private VERSION As Double = 1.0

	Dim Snotif As Notification
	
	'Definim un tipus especial per a cada mongo
	Type chType( soundfile As String, sp_id As Int,bitmap_name As String, bitmap As Bitmap, wwe As Int, hhe As Int)
	Type chElement( id As Int, instance As JavaObject, ttype As chType, active As Boolean, xpos As Int, ypos As Int)
	
	Dim PICTYPE As chType 
	Dim DROPTYPE As chType 
	
	Dim myChatHeadsMap As Map


	'================================================================
	' Sound (if needed)
	'================================================================
	Dim sp As SoundPool
	Dim sp_id As Int	
	
	Dim t As Timer
	Dim index_move As Int
	Dim pos_final As Float
	Dim mstep As Float
	
End Sub


Sub Service_Create
	
	'Init PICTYPE
	PICTYPE.Initialize
	PICTYPE.soundfile="magic.mp3"
	PICTYPE.bitmap_name="person.png"
	PICTYPE.wwe=60dip
	PICTYPE.hhe=60dip

	Dim dstRect As Rect
	dstRect.Initialize(0,0,PICTYPE.wwe,PICTYPE.hhe)
	
	PICTYPE.bitmap.InitializeMutable(PICTYPE.wwe,PICTYPE.hhe)
	Dim cve As Canvas
	cve.Initialize2(PICTYPE.bitmap)	
	cve.DrawBitmap(LoadBitmap(File.DirAssets,PICTYPE.bitmap_name),Null,dstRect)


	'Dim DROPTYPE As chType'=(0,Null,"drop.png",,172dip,108dip)
	DROPTYPE.Initialize
	DROPTYPE.soundfile="magic.mp3"
	DROPTYPE.bitmap_name="drop.png"
	DROPTYPE.wwe=60dip
	DROPTYPE.hhe=60dip

	Dim dstRect As Rect
	dstRect.Initialize(0,0,DROPTYPE.wwe,DROPTYPE.hhe)
	
	DROPTYPE.bitmap.InitializeMutable(DROPTYPE.wwe,DROPTYPE.hhe)
	Dim cve As Canvas
	cve.Initialize2(DROPTYPE.bitmap)	
	cve.DrawBitmap(LoadBitmap(File.DirAssets,DROPTYPE.bitmap_name),Null,dstRect)
	

	sp.Initialize(2)	'as many as different element types
	If PICTYPE.soundfile<>Null Then 
		PICTYPE.sp_id = sp.Load(File.DirAssets,PICTYPE.soundfile)
	Else
		PICTYPE.sp_id=-1
	End If
		
	If DROPTYPE.soundfile<>Null Then 
		DROPTYPE.sp_id = sp.Load(File.DirAssets,DROPTYPE.soundfile)
	Else
		DROPTYPE.sp_id=-1
	End If
		


	'Notif needed for foreground service
	Snotif.Initialize
	Snotif.SetInfo("ChatHead demo", "Press to change settings", Main)
	Snotif.Icon="icon"
	Snotif.Vibrate=False
	Snotif.Sound=False
	Service.StartForeground(1, Snotif)
	
	t.Initialize("tt",100)
	t.Enabled=False
		
End Sub

Sub Init_elements
	
	Dim J As JavaObject
	J.InitializeContext

	Dim a As LayoutValues=GetDeviceLayoutValues 'sembla q l'hem de cridar 1 primer cop, si no dona null
	
	'==============================================================================
	'Create elements. Use a map to ease creating as many as needed.
	'==============================================================================
	Dim elements As Map
	elements.Initialize
	
	elements.Put("pic",1)
	'elements.Put("drop",1)	'Coming soon
	

	myChatHeadsMap.Initialize

	Dim id As Int=0
	
	For Each descriptor As String In elements.Keys
		
		Dim num_instances As Int = elements.Get(descriptor)
		For k=0 To num_instances-1
	
			Dim myChatHead As chElement
			myChatHead.Initialize
			If descriptor="pic"    Then myChatHead.ttype=PICTYPE
			If descriptor="drop"   Then myChatHead.ttype=DROPTYPE

			myChatHead.active=True
			myChatHead.id=id
			myChatHead.instance=J.RunMethod("newInstance2",Array(J,id))

			Dim Rect1 As Rect
			Rect1.Initialize(0,0,myChatHead.ttype.wwe,myChatHead.ttype.hhe)
			Dim bbb As Bitmap
			bbb.InitializeMutable(myChatHead.ttype.wwe,myChatHead.ttype.hhe)
			Dim cv As Canvas
			cv.Initialize2(bbb)
 			cv.DrawBitmap(myChatHead.ttype.bitmap,Null,Rect1)
			cv.DrawCircle(myChatHead.ttype.wwe/2,myChatHead.ttype.hhe/2,myChatHead.ttype.wwe/2-1dip,Colors.ARGB(200,255,255,255),False,1dip)
			myChatHead.instance.RunMethod("setImageBitmap",	Array(bbb))	

			Dim xxe As Int =0	'Rnd(0,a.Width-myChatHead.ttype.wwe)
			Dim yye As Int =Rnd(0,a.Height-myChatHead.ttype.hhe)
	
			myChatHead.instance.RunMethod("mSetPos",Array(xxe,yye))
			
			'Add to the map
			myChatHeadsMap.Put(id,myChatHead)
			
			id=id+1
		Next
	Next

	'Service.StartForeground(IsDevTool,noti)
	
	
End Sub



Sub Service_Start (StartingIntent As Intent)
	
	If Starter.MYSERVICE=True Then
		Init_elements
	End If
	Log("oService Start!")

End Sub


Sub Service_Destroy
	
	Log("oService.Destroy")
	t.Enabled=False
	For Each mChatHead As chElement In myChatHeadsMap.Values
		If mChatHead.instance<> Null Then
			
			Try
				mChatHead.instance.RunMethod("removeView",Null)
				mChatHead.instance=Null
				Log("Removing")
			Catch 
				Log("Something went wrong!")
			End Try
		End If	
	Next
	
End Sub

Sub Sound(sid As Int)
	If sid<>-1 Then
		sp.Play(sid,1,1,100000,1,1)	
	End If
End Sub

Sub ondouble_tap( id As Int)
	
	'Log("Double Tap")
	If Starter.DOUBLETAPBEHAVIOUR=1 Then
		
		Dim mChatHead As chElement = myChatHeadsMap.Get(id)
		If mChatHead<>Null Then
			sp.Play(mChatHead.ttype.sp_id,1,1,10,0,1)					
		End If
		
	Else if Starter.DOUBLETAPBEHAVIOUR=2 Then	
		
		StopService(Me)
	End If
End Sub

Sub action_down( x As String)

	'Your code here
End Sub

'Drag event is handled internally. But here some params are passed in case you want to perform 
'different actions based on ellapsed time and positions
'
' x(0) -> Id
' x(1) -> ellapsed time (milliseconds)
' x(2),x(3) -> x0,y0
' x(4),x(5) -> x1,y1
Sub action_drag( x() As Float)

	'Log("Dragged!")

	Dim index As Int = x(0)
	
	Dim mChatHead As chElement = myChatHeadsMap.Get(index)
	
	If mChatHead<>Null Then
		
		Dim eTime As Int = x(1)			'Not used here. In case you want to perform some action based on time and coordinates
		Dim incx As Int = x(4)-x(2)
		Dim incy As Int = x(5)-x(3)

		Dim a As LayoutValues=GetDeviceLayoutValues 	
		mChatHead.xpos = mChatHead.instance.RunMethod("mGetPosX",Null)	
	
		If Starter.STICK_TO_BORDER=True Or mChatHead.xpos<0 Or mChatHead.xpos>(a.Width-mChatHead.ttype.wwe) Then 
			
			'Are we more near to the left than to the right?
			If x(4)+(mChatHead.ttype.wwe/2)<(a.Width/2) Then
				'Stick to the left
				mChatHead.ypos = mChatHead.instance.RunMethod("mGetPosY",Null)
				mChatHead.xpos=0
			Else
				' Stick to the right
				mChatHead.ypos = mChatHead.instance.RunMethod("mGetPosY",Null)
				mChatHead.xpos=a.Width-mChatHead.ttype.wwe
				'mChatHead.instance.RunMethod("mSetPos",Array(mChatHead.xpos,mChatHead.ypos))
				
			End If

			CallSubDelayed2(Me,"MoveIt",mChatHead)
			
		End If
		' Your code here	
	End If			

End Sub

Sub MoveIt( mobj As chElement)

	mobj.instance.RunMethod("mSetPos",Array(mobj.xpos,mobj.ypos))
End Sub

Sub  tt_Tick
	
End Sub

' From https://github.com/usmanalibutt/android-HomeScreenOverlay/tree/master/res

#if JAVA

import android.content.Context;
import android.graphics.PixelFormat;
import android.util.AttributeSet;
import android.view.GestureDetector;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.Toast;
import android.os.PowerManager;

public class CustomImageView extends ImageView {

	public CustomImageView(Context context) {
		super(context);
		sharedConstructing(context);
		isBeingTouched=0;
	}
	public CustomImageView(Context context,int myIndex) {
		super(context);
		index=myIndex;
		sharedConstructing(context);
		isBeingTouched=0;
	}
	
	private WindowManager windowManager;
	private WindowManager.LayoutParams params;
	private GestureListener mGestureListener;
	private GestureDetector mGestureDetector;
	private Context context;
	
	private int isBeingTouched;
	private int index;
	private int xmax,ymax;
	
	private void sharedConstructing(Context context) {
		super.setClickable(true);

		this.context = context;
		windowManager = (WindowManager) context
				.getSystemService(Context.WINDOW_SERVICE);

		params = new WindowManager.LayoutParams(
				WindowManager.LayoutParams.WRAP_CONTENT,
				WindowManager.LayoutParams.WRAP_CONTENT,
				WindowManager.LayoutParams.TYPE_PHONE,//TYPE_SYSTEM_ALERT,
				WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE | WindowManager.LayoutParams.FLAG_LAYOUT_NO_LIMITS,
				PixelFormat.TRANSLUCENT);

		params.gravity = Gravity.TOP | Gravity.LEFT;
		params.x = 0;
		params.y = 100;

		windowManager.addView(this, params);

		mGestureListener = new GestureListener();
		mGestureDetector = new GestureDetector(context, mGestureListener, null,
				true);

		setOnTouchListener(new OnTouchListener() {

			private int initialX;
			private int initialY;
			private float initialTouchX;
			private float initialTouchY;
			private long ellapsedTime;
			private int bPrimerTouch;
			private float[] dades=new float[50]; 

			@Override
			public boolean onTouch(View v, MotionEvent event) {
				mGestureDetector.onTouchEvent(event);

				switch (event.getAction()) {
				case MotionEvent.ACTION_DOWN:
					isBeingTouched=1;
					bPrimerTouch=1;
					initialX = params.x;
					initialY = params.y;
					initialTouchX = event.getRawX();
					initialTouchY = event.getRawY();
					ellapsedTime = System.currentTimeMillis();
					//processBA.raiseEvent(null, "action_down", "abc");
					return true;
				case MotionEvent.ACTION_UP:
				
					//BA.Log("X:"+params.x);
					//BA.Log("Y:"+params.y);
					ellapsedTime=System.currentTimeMillis() - ellapsedTime;
					dades[0]=index;
					dades[1]=(float)ellapsedTime;
					dades[2]=initialX;
					dades[3]=initialY;
					dades[4]=params.x;
					dades[5]=params.y;
					if ((System.currentTimeMillis() - ellapsedTime)>200)
							processBA.raiseEvent(null, "action_drag", dades);
					else{
						params.x = initialX	;
						params.y = initialY	;
						windowManager.updateViewLayout(CustomImageView.this, params);
					}

					isBeingTouched=0;				
					v.performClick();
							
					return true;
				case MotionEvent.ACTION_MOVE:
				
					if ( bPrimerTouch>0){
					
						if ((System.currentTimeMillis() - ellapsedTime)>60){
							bPrimerTouch=0;
							processBA.raiseEvent(null, "action_down", "abc");	
						}
					}
					params.x = initialX	+ (int) (event.getRawX() - initialTouchX);
					params.y = initialY	+ (int) (event.getRawY() - initialTouchY);
					windowManager.updateViewLayout(CustomImageView.this, params);
					return true;
				}
				return false;
			}

		});
	}

	//JCP
	public void mmove(int difx, int dify,int x_max, int y_max ){

		if (isBeingTouched>0) return; //Don't interfere with current deag
		
		xmax=x_max;
		ymax=y_max;		
		
		params.x = params.x + difx;
		if (params.x<0) params.x=0;
		if (params.x>(xmax-100)) params.x=(xmax-100);	
		params.y = params.y + dify;
		if (params.y<0) params.y=0;
		if (params.y>(ymax-100)) params.y=(ymax-100); 
					
		windowManager.updateViewLayout(CustomImageView.this, params);
	}
	
	public void mSetPos(int x, int y){
	
		if (isBeingTouched>0) return;
		params.x = x;
		params.y = y;
		windowManager.updateViewLayout(CustomImageView.this, params);
	}
	
	public int mGetPosX(){
		return params.x;
	}
	public int mGetPosY(){
		return params.y;
	}

	public void removeView() {
		windowManager.removeView(this);
	}

	public class GestureListener extends
			GestureDetector.SimpleOnGestureListener {

		@Override
		public boolean onDoubleTap(MotionEvent e) {
		
			//Toast.makeText(context, "taptap!!!", Toast.LENGTH_LONG).show();
			
			//http://www.b4x.com/android/forum/threads/accessing-inline-data-from-basic.54291/#post-340704
			processBA.raiseEvent(null, "ondouble_tap", index);
			return true;
		}
	}
}

public CustomImageView newInstance(Context context){

	CustomImageView c = new CustomImageView(context);
	return(c);
}

public CustomImageView newInstance2(Context context,int index){

	CustomImageView c = new CustomImageView(context,index);
	return(c);
}

// Test with bool --> "boolean" diferent to "Boolean"(!?)
public int  isMyScreenOn(){
	PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
	int /*boolean*/ isScreenOn=0;//false;
	if (android.os.Build.VERSION.SDK_INT >= 21) {
		if (pm.isInteractive()==true) isScreenOn=1;
		//isScreenOn=pm.isInteractive();
	}else{
		if (pm.isScreenOn()==true) isScreenOn=1;
		//isScreenOn = pm.isScreenOn();
	}
	return isScreenOn;
}


#End if


